package zero1hd.polyjet.ui.builders;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.math.Rectangle;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.Widget;
import com.badlogic.gdx.scenes.scene2d.utils.ScissorStack;

public class ScrollText extends Widget {
	Rectangle scissors = new Rectangle();
	Rectangle clipBounds = new Rectangle();
	
	String text;
	BitmapFont font;
	
	public ScrollText(String text, Skin skin) {
		this.text = text;
		font = skin.getFont("default-font");
		setWidth(20f);
		setHeight(40f);
	}
	
	@Override
	public void layout() {
		clipBounds.setPosition(getX(), getY());
		clipBounds.setSize(getWidth(), getHeight());
		super.layout();
	}
	
	@Override
	public void draw(Batch batch, float parentAlpha) {
		ScissorStack.calculateScissors(getStage().getCamera(), batch.getTransformMatrix(), clipBounds, scissors);
		if (ScissorStack.pushScissors(scissors)) {
			font.draw(batch, text, getX(), getY());
			batch.flush();
			ScissorStack.popScissors();
		};
		
		super.draw(batch, parentAlpha);
	}
}
